'
' CMKEYDMO.BAS                    Sun  12-23-1990  21:12:58 
'
'
'                       (C) 1990, JERRY OWENS, DBA
'                       VANGUARD MANAGEMENT SYSTEMS
'                    
'                    P.O. Box 1582  Tupelo, MS 38801
'                     
'                              601-862-2346
'
'
'
'       Purpose: To provide expanded keyboard command options 
'                When called COMKEY waits for a key to be pressed
'                and then returns values from 1 to ...
'                depending upon the key pressed and which shift
'                keys were engaged at the time.   With the unshifted,
'                Shift, Control, and Alternate combinations, eight
'                possiblities are available for most keys.
'
'                In those cases where the keyboard does not respond
'                for a particular combination, COMKEY reserves a number
'                anyway to keep its number sequence in order.
'
'       Syntax:  cmd = COMKEY(ACode, SCode, Flag)
'
'                cmd will be the COMKEY code
'
'                ACode will be the ASCII code and SCode the Scancode
'                returned by the keyboard
'
'                Flag will indicated which shift and/or toggle keys
'                were engaged:
'
'                       Left Shift:      Flag AND 1
'                       Right Shift:     Flag AND 2
'                       Control Key:     Flag AND 4
'                       Alternate Key:   Flag AND 8
'                       Insert Key:      Flag AND 16
'                       CapsLock Key:    Flag AND 32
'                       NumLock Key:     Flag AND 64
'                       ScrolLock Key:   Flag AND 128
'
'               If a mouse button was pressed, COMKEY will be:
'                       Left Button:     1001
'                       MiddleButton:    1002
'                       Right Button:    1004
'
'
'       Usage:          cmd = COMKEY(ACode,SCode,Flag)
'                       SELECT CASE cmd
'                           CASE 1 to 8         ' they pressed an 'A'
'                              .                ' of some kind   
'                              .
'                              .
'                           CASE 105 TO 112     ' an N, so they must
'                              .                  mean NO
'                              .
'                           CASE 193 TO 200     ' or YES since this is Y
'                              .
'                              .
'                           CASE 399            ' CTRL ALT ESCAPE
'                              .
'                              .
'                           CASE 430            ' SHIFT ALT DOWN ARROW
'                              .
'                              .
'                           CASE 
'                              .
'                              .
'                           CASE 592            ' SHIFT CTRL ALT F12
'                              . 
'                              .
'                       END SELECT
'
'
' Things to Note:  Codes 495 CTRL_ALT_DELETE 
'                    and 496 SHIFT_CTRL_ALT_DELETE will reboot your
'                  machine ... use caution around them.
'                  Same for the period on the keypad
'               
'
'                  CTRL_M is NOT the same as RETURN
'                  the M key returns COMKEY Codes 97 thru 104
'
'                  RETURN (and the grey ENTER) return 377 thru 384
'
'                  The number 5 on the keypad is a special case
'                  The other keys there do double duty as cursor
'                  or editing keys, and 5 is actually listed as
'                  CENTER in the QB manual... so, I squeezed out
'                  four more COMKEY codes: 625 thur 628
'
'                  If you really wanted to, you could get more codes
'                  out of the keypad keys by taking the status of
'                  of the NUMLOCK toggle into account, some 590 active
'                  control codes seemed like enough to me.
'
'
' Library Subs:    COMKEY makes use of three PROBAS Subprograms
'                  from Hammerly Computer Services, Inc.:
'
'                  GETKEY3(Mouse, AscCode, ScanCode, Lft, Mid, Rgh) 
'                  GETKBD(Insert, CapsLock, NumLock, ScrolLock)     
'                  GETKBD1(LSHIFT, RSHIFT, CTRL, ALT)               
'
'                  You must have these for COMKEY to work.
'                  Hammerly Computer Services, Inc., 414 Main Street
'                  Laurel, MD 20707
'
'
'
'
REM $INCLUDE: 'd:\probas\probas.dec'
'

        DEFINT A-Z

        DECLARE SUB GETKEY3(Mouse, AscCode, ScanCode, Lft, Mid, Rgh) 
        DECLARE SUB GETKBD(Insert, CapsLock, NumLock, ScrolLock)     
        DECLARE SUB GETKBD1(LSHIFT, RSHIFT, CTRL, ALT)               

        DECLARE FUNCTION COMKEY% (ACode%, SCode%, Flag%)
        
        
'-------------------------------------------------------------------
'this little loop just repeatedly calls COMKEY and prints out the
'result until you press SHIFT_CTRL_ALT_ESCAPE (whose code, BTW,
'is 400).  
'-------------------------------------------------------------------
        
        esc = 400
        DO WHILE -1
            'OPEN "COMKEY.DAT" FOR APPEND AS 1
            cmd = COMKEY%(ACode, SCode, Flag)
            format$ = "Cmd: ###   ACode: ###   SCode: ###   Flag: ###"
            PRINT USING format$; Cmd; ACode; SCode; Flag
            'PRINT #1, USING format$; Cmd; ACode; SCode; Flag
            'CLOSE 1
            if cmd = esc then exit do
        LOOP


